/* Root Variables: Define color themes and other design constants */
:root {
    --font-family: 'Cantarell', sans-serif;

    /* Primary Colors */
    --primary-light: #FFFFFF;
    --primary-dark: #2E2E2E;

    /* Secondary Colors */
    --secondary-light: #f9f9f8;
    --secondary-dark: #333333;

    /* Tertiary Colors */
    --tertiary-light: #EDEDED; /* Used for all the card backgrounds */
    --tertiary-dark: #242424;

    /* Accent Colors */
    --accent-color: #BA6EFF;

    /* Text Colors */
    --text-light: #2E3436;
    --text-dark: #E5E5E5;

    /* Border Colors */
    --text-light-hover: #C0C0C0;
    --text-dark-hover: #555555;

    --card-bg-color: #EDEDED;






    /* Light mode settings */
    --background-color: #F6F5F4;

    --button-hover-border-color: #979499;

    --column-header-color: #555753;
    --control-panel-hover-text-color: #555753;

    --control-panel-button-color: #B0B0B0;





    /* Dark mode settings */
/*    --secondary-dark: #242424;*/

    --button-hover-border-color-dark: #888888;


    --control-panel-button-color-dark: #AAAAAA;
    --column-header-color-dark: #AAAAAA;


    --control-panel-hover-text-color-dark: #E5E5E5;
    --primary-light-dark: #E5E5E5;
    --text-color-dark: #E5E5E5;
}

    /* General Body Styling: Applies to the entire page */
    body {
        font-family: var(--font-family);
        background-color: var(--secondary-light);
        color: var(--text-light);
        margin: 0;
        display: flex;
        justify-content: center;
        transition: background-color 0.3s, color 0.3s;
    }

    /* Dark Mode Body Styling */
    body.dark-mode {
        background-color: var(--secondary-dark);
        color: var(--text-color-dark);
    }

    /* Kanban Board Styling */
    .kanban-board {
        position: relative;
        box-sizing: border-box;
        min-height: 100vh;
        max-height: 100vh;
        display: flex;
        overflow: auto;
        width: 100vw;
        align-items: flex-start;
        white-space: nowrap;
        transition: transform 0.3s ease;
    }

.kanban-board.shift-right {
    transform: translateX(280px);
}


    /* Kanban Column Styling */
    .kanban-column {
        min-width: 260px;
        max-width: 260px;
        background-color: var(--primary-light);
        border-radius: 8px;
        padding: 15px;
        margin: 10px;
        box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
        box-sizing: border-box;
        max-height: none;
        overflow-x: hidden;
        overflow-y: visible;
        direction: ltr; /* Reset text direction to left-to-right inside the column */
        transition: background-color 0.3s, color 0.3s;
/*        cursor: grab;*/
    }

    /* Dark Mode Kanban Column Styling */
    body.dark-mode .kanban-column {
        background-color: var(--primary-dark);
    }

    /* Kanban Column Header Styling */
    .kanban-column h2 {
        color: var(--column-header-color);
        font-size: 1.2em;
        margin-top: 0;
        transition: background-color 0.3s, color 0.3s;
    }

    /* Dark Mode Kanban Column Header Styling */
    body.dark-mode .kanban-column h2 {
        color: var(--column-header-color-dark);
    }

    /* Kanban Card Styling */
    .kanban-card {
        white-space: normal;
        word-wrap: break-word;
        position: relative;
        background-color: var(--tertiary-light);
        padding: 10px;
        margin-top: 10px;
        border-radius: 4px;
        cursor: grab;
/*        caret-shape: block;*/
        transition: background-color 0.3s, outline 0.05s, box-shadow 0.3s; /* Smooth transition */
        box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
        display: flex;
        flex-direction: column;
    }

    /* Dark Mode Kanban Card Styling */
    body.dark-mode .kanban-card {
        background-color: var(--secondary-dark);
    }

    /* Kanban Card Hover Styling */
    .kanban-card:hover {
        outline: 2px solid var(--accent-color);
        outline-offset: 2.5px;
    }

    /* Dark Mode Kanban Card Hover Styling */
    body.dark-mode .kanban-card:hover {
        outline: 2px solid var(--accent-color);
    }

    /* Kanban Card Active and Focus Styling */
    .kanban-card:active,
    .kanban-card:focus {
        box-shadow: 0 0 10px rgba(0, 0, 0, 0.3);
    }

    /* Responsive Styling for Smaller Screens */
    @media (max-width: 768px) {
        .kanban-board {
            flex-direction: column;
        }
        .kanban-card {
            flex-direction: row;
        }
        .kanban-column {
            width: 100%;
        }
        .header-group {
            flex-direction: row;
        }
    }

    /* Header Group Styling */
    .header-group {
        display: flex;
        align-items: center;
    }

    /* Rename Column Button Hover Styling */
    .header-group:hover .rename-column-button {
        opacity: 1;
    }

    /* Rename Column Button Styling */
    .rename-column-button {
        width: 24px;
        height: 24px;
        background-color: var(--text-light);
        color: var(--text-light-hover);
        font-size: 20px;
        line-height: .5;
        border: 1px solid var(--text-light-hover);
        border-radius: 4px;
        cursor: pointer;
        margin-right: 10px;
        margin-bottom: 15px;
        margin-left: 10px;
        opacity: 0;
        transition: opacity 0.1s ease;
    }

.rename-column-button svg {
    width: 24px;
    height: 24px;
    transform: translate(-20%, -10%);
    fill: currentColor;
}

    /* Dark Mode Rename Column Button Styling */
    body.dark-mode .rename-column-button {
        background-color: var(--secondary-dark);
        color: var(--text-dark-hover);
        border: 1px solid var(--text-dark-hover);
    }

    /* Input Group Styling */
    .input-group {
        position: relative;
        display: flex;
        box-sizing: border-box;
    }

    /* Input Group Span Styling */
    .input-group span {
        position: absolute;
        right: 8px;
        top: 50%;
        transform: translateY(-315%);
        font-size: 10px;
        color: grey;
        transition: color 0.3s;
    }

    /* Invisible Span Styling */
    .input-group span.invisible {
        visibility: hidden;
    }

    /* Input Field Styling */
    .input-group input {
        padding: 8px 12px 8px 8px;
        margin-bottom: 10px;
        border: 1px solid var(--text-light-hover);
        border-radius: 4px;
        font-size: 16px;
        color: var(--text-light);
        background-color: var(--primary-light);
        flex-grow: 1;
        width: 100%;
        caret-color: var(--accent-color);
        box-sizing: border-box; /* Include padding and border in the element's total width and height */
        transition: background-color 0.3s, border-color 0.3s, color 0.3s, caret-color 0.3s;
    }

    /* Dark Mode Input Field Styling */
    body.dark-mode .input-group input {
        border: 1px solid var(--text-dark-hover);
        background-color: var(--primary-dark);
        color: var(--text-color-dark);
        caret-color: var(--accent-color);
    }

    /* Input Field Focus Styling */
    .input-group input:focus {
        outline: none;
    }

    /* Input Group Button Styling */
    .input-group button {
        position: absolute;
        right: 11px;
        top: 50%;
        transform: translateY(-70%); /* plus button on hover */
        width: 24px;
        height: 24px;
        background-color: var(--text-light);
        color: var(--text-light-hover);
        font-size: 20px;
        border: 1px solid var(--text-light-hover);
        border-radius: 4px;
        cursor: pointer;
        opacity: 0;
        transition: opacity 0.1s ease, background-color 0.3s, border-color 0.3s, color 0.3s;
        display: flex;
        align-items: center;
        justify-content: center;
    }

    /* Dark Mode Input Group Button Styling */
    body.dark-mode .input-group button {
        background-color: var(--secondary-dark);
        color: var(--text-dark-hover);
        border: 1px solid var(--text-dark-hover);
    }

    /* Input Group Button Hover Styling */
    .input-group button:hover {
        border: 1px solid var(--button-hover-border-color);
        color: var(--button-hover-border-color);
    }

    /* Dark Mode Input Group Button Hover Styling */
    body.dark-mode .input-group button:hover {
        border: 1px solid var(--button-hover-border-color-dark);
        color: var(--button-hover-border-color-dark);
    }

    /* Dragging Kanban Card Styling */
    .kanban-card.dragging {
        opacity: 0.8;
        box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);
    }

    /* Drop Indicator Styling */
    .drop-indicator {
        height: 4px;
        background: var(--accent-color);
        width: 90%;
        margin: 3px auto;
        border-radius: 4px;
    }

    /* Dark Mode Drop Indicator Styling */
    body.dark-mode .drop-indicator {
        background: var(--accent-color);
    }

/* Control panel styling */
.control-panel {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: flex-start;
    padding: 10px;
    margin-right: 10px;
    margin-top: 10px;
    background-color: var(--primary-light);
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    transition: background-color 0.3s, height 0.4s ease;
    border-radius: 8px;
    overflow: hidden;
}

.control-panel.expanded {
    height: auto;
}

body.dark-mode .control-panel {
    background-color: var(--primary-dark);
}

#controlPanelsContainer {
    display: flex;
    position: fixed;
    right: 0;
    top: 0;
    flex-direction: column;
    align-items: center;
    color: transparent !important;
    background-color: transparent !important;
    z-index: 10;
}


#toggleControlPanelButton {
    display: block;
    margin-top: 0px;
}

#projectsButton {
    display: block;
    margin-top: 0px;
}

#settingsButton {
    display: block;
    margin-top: 0px;
}

#toggleIcon svg {
    width: 24px;
    height: 24px;
    transform: translate(-2%, -3%);
    padding: none;
    margin: none;
    fill: currentColor;
}

    /* Control Panel Button Styling */
    .control-panel button {
        padding: 10px;
        margin-top: 10px;
        border: none;
        box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
        transition: background-color 0.3s, color 0.3s;
        background-color: var(--primary-light);
        color: var(--primary-dark); /* SVG outline colouring */
        font-size: 20px;
        cursor: pointer;
        border-radius: 6px;
        line-height: normal;
        text-align: center;
        display: none;
        align-items: center;
        justify-content: center;
    }

    /* Dark Mode Control Panel Button Styling */
    body.dark-mode .control-panel button {
        background-color: var(--primary-dark);
        color: var(--control-panel-button-color-dark);
    }

    /* Control Panel Button Hover Styling */
   .control-panel button:hover {
        outline: 2px solid var(--accent-color);
        outline-offset: 2.5px;
    }

    body.dark-mode .control-panel button:hover {
        outline: 2px solid var(--accent-color);
    }

/* Control Panel Button Tooltip Styling */
.control-panel button:not(#toggleControlPanelButton):hover::after {
    content: attr(data-title);
    display: block;
    position: absolute;
    transform: translate(-130%,-120%);
    white-space: nowrap;
    background-color: var(--primary-light);
    color: var(--control-panel-hover-text-color);
    font-size: 0.8em;
    font-weight: bold;
    padding: 6px 12px;
    border-radius: 6px;
    opacity: 1;
    transition: background-color 0.3s, border-color 0.3s, color 0.3s;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18); /* Add some shadow for better visibility */
}

body.dark-mode .control-panel button:not(#toggleControlPanelButton):hover::after {
    background-color: var(--primary-dark);
    color: var(--control-panel-hover-text-color-dark);
}


/* Button Panel Styling for Kanban Card */
.button-panel {
    display: flex;
    justify-content: flex-start;
    width: 100%;
    margin-top: 10px;
    background-color: var(--tertiary-light);
    border-radius: 4px;
    transition: background-color 0.3s;
}

body.dark-mode .button-panel {
    background-color: var(--secondary-dark);
}

/* Button Styling within the Panel */
.button-panel panel-button {
    background-color: var(--secondary-light);
    width: 24px;
    height: 24px;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    border-radius: 4px;
    cursor: pointer;
    display: flex;
    align-items: center;
    justify-content: right;
    transition: background-color 0.3s, border-color 0.3s, color 0.3s;
    margin-right: 7px;
}

.button-panel panel-button svg {
    width: 16px;
    height: 16px;
    transform: translateX(-25%);
    padding: none;
    margin: none;
    fill: currentColor;
}

body.dark-mode .button-panel panel-button {
    background-color: #444444;
    color: var(--text-dark-hover);
}

.button-panel panel-button:hover {
    outline: 2px solid var(--accent-color);
    outline-offset: 2.5px;
}

body.dark-mode .button-panel panel-button:hover {
    outline: 2px solid var(--accent-color);
}

/* General button styling */
.button-with-icon {
    width: 40px;
    height: 40px;
/*    background-color: var(--text-light);*/
/*    color: currentColor;*/
    color: var(--secondary-light);
/*    border: 1px solid var(--text-light-hover);*/
    border-radius: 4px;
    cursor: pointer;
    display: flex;
    line-height: normal;
    align-items: center;
    justify-content: center;
    transition: background-color 0.3s, color 0.3s;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    flex-shrink: 0;
    padding: 0;
    margin: 0;
    border: none;
}

body.dark-mode .button-with-icon {
    background-color: var(--secondary-dark);
    color: var(--primary-light-dark);
}




.projects-tray-buttons {
    display: flex;
    column-gap: 10px;
}

.project-button {
    width: 36px;
    height: 36px;
    background-color: var(--tertiary-light);
    color: var(--column-header-color);
    border-radius: 6px;
    cursor: pointer;
    display: flex;
    line-height: normal;
    align-items: center;
    justify-content: center;
    transition: background-color 0.3s, color 0.3s;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    flex-shrink: 0;
    padding: 0;
    margin: 0;
    border: none;
    transform: translateY(50%);
}

.project-button:hover {
    outline: 2px solid var(--accent-color);
    outline-offset: 2.5px;
}

.project-button svg {
    width: 32px;
    height: 32px;
    fill: currentColor;
}

body.dark-mode .project-button {
    background-color: var(--secondary-dark);
    color: var(--primary-light-dark);
}

/*.button-with-icon:hover {*/
/*    color: var(--button-hover-border-color);*/
/*}*/

/*body.dark-mode .button-with-icon:hover {*/
/*    color: var(--button-hover-border-color-dark);*/
/*}*/

/* Ensure SVGs are centered */
.button-with-icon svg {
    width: 26px;
    height: 26px;
    transform: translate(-10%, -5%);
    padding: none;
    margin: none;
    fill: currentColor;
}

/* Settings panel styling */
.settings-panel {
    display: flex;
    flex-direction: column;
    align-items: center; /* Center buttons horizontally */
    justify-content: flex-start;
    padding: 10px;
    margin: 10px;
    width: 30px;
    height: 30px;
    background-color: var(--primary-light);
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    transition: background-color 0.3s, height 0.4s ease;
    border-radius: 8px;
}

body.dark-mode .settings-panel {
    background-color: var(--primary-dark);
}

/* Settings Panel Button Styling */
.settings-panel button {
    padding: 10px;
    margin-bottom: 10px;
    border: none;
    background-color: var(--primary-light);
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    color: var(--primary-dark);
    font-size: 20px;
    cursor: pointer;
    width: 40px;
    height: 40px;
    border-radius: 6px;
    line-height: normal;
    text-align: center;
    transition: background-color 0.3s, color 0.3s;
    display: none;
    align-items: center;
    justify-content: center;
}

/* Dark Mode Settings Panel Button Styling */
body.dark-mode .settings-panel button {
    background-color: var(--primary-dark);
    color: var(--control-panel-button-color-dark);
}

/* Settings Panel Button Hover Styling */
.settings-panel button:hover {
    outline: 2px solid var(--accent-color);
    outline-offset: 2.5px;
}

body.dark-mode .settings-panel button:hover {
    outline: 2px solid var(--accent-color);
}

/* Settings Panel Button Tooltip Styling */
.settings-panel button:hover::after {
    content: attr(data-title);
    display: block;
    position: absolute;
    transform: translate(-130%, -120%);
    white-space: nowrap;
    background-color: var(--primary-light);
    color: var(--control-panel-hover-text-color);
    font-size: 0.8em;
    font-weight: bold;
    padding: 6px 12px;
    border-radius: 6px;
    opacity: 1;
    transition: background-color 0.3s, border-color 0.3s, color 0.3s;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18); /* Add some shadow for better visibility */
}

body.dark-mode .settings-panel button:hover::after {
    background-color: var(--primary-dark);
    color: var(--control-panel-hover-text-color-dark);
}






/* Projects Tray */
.projects-tray {
    position: fixed;
    top: 0;
    left: 0;
    width: 260px;
    height: 100%;
    background-color: var(--primary-light);
    border-radius: 8px 48px 8px 8px;
    padding: 15px;
    margin: 10px;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    box-sizing: border-box;
    overflow-x: hidden;
    overflow-y: auto;
    transition: transform 0.3s ease, background-color 0.3s, color 0.3s;
    transform: translateX(-120%); /* Initially hide the tray off-screen to the left */
    z-index: 1002;
}

.projects-tray.visible {
    transform: translateX(0); /* Slide the tray in from the left */
}

/* Dark Mode Projects Tray */
body.dark-mode .projects-tray {
    background-color: var(--primary-dark);
}

/* Projects Tray Header */
.projects-tray-header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 25px;
}

/* User Profile */
.user-profile {
    width: 72px;
    height: 72px;
    border-radius: 50%;
    overflow: hidden;
    cursor: pointer;
    transition: border-color 0.3s;
    display: flex;
    align-items: center;
    justify-content: center;
    background-color: var(--tertiary-light);
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    transform: translateX(-6%);
}

body.dark-mode .user-profile {
    background-color: #bfbfbf;
    color: var(--primary-dark);
}

.user-profile:hover {
    outline: 2px solid var(--accent-color);
    outline-offset: 2.5px;
}

.user-profile svg {
    width: 36px;
    height: 36px;
    fill: currentColor;
}

.user-profile img {
    display: none; /* Hide image initially */
    width: 100%;
    height: 100%;
    object-fit: cover;
    border-radius: 50%;
}

/* Project Item */
.project-item {
    background-color: var(--secondary-light);
    border-radius: 8px;
    padding: 10px;
    margin-bottom: 15px;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    cursor: pointer;
    transition: background-color 0.3s, box-shadow 0.3s;
}

.project-header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 10px;
}

.project-title {
    font-weight: bold;
    font-size: 1.2em;
    color: var(--column-header-color);
}

/* Dark Mode Project Title */
body.dark-mode .project-title {
    color: var(--column-header-color-dark);
}

body.dark-mode .board-item {
    background-color: var(--secondary-dark);
}

body.dark-mode .project-option {
    background-color: var(--secondary-dark);
    color: var(--text-dark-hover);
}

body.dark-mode .project-item {
    background-color: var(--primary-dark);
}

/* Board Item */
.board-item {
    background-color: var(--tertiary-light);
    padding: 10px;
    margin-bottom: 10px;
    border-radius: 4px;
    cursor: pointer;
    transition: background-color 0.3s;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
}

/*!* Project Options *!*/
.project-option {
    width: 24px;
    height: 24px;
    background-color: var(--tertiary-light);
    color: var(--column-header-color);
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12), 0 2px 1.5px rgba(0, 0, 0, 0.18);
    border-radius: 4px;
    cursor: pointer;
    display: flex;
    align-items: center;
    transition: background-color 0.3s, border-color 0.3s, color 0.3s;
    border: none;
}

.project-options-container {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    gap: 7px;
}

.project-options-container svg {
    width: 24px;
    height: 24px;
    fill: currentColor;
}

/* Hover States */
.project-item:hover {
    outline-offset: 2.5px;
    outline: 2px solid var(--accent-color);
}

.project-option:hover {
/*    color: var(--button-hover-border-color);*/
    outline-offset: 2.5px;
    outline: 2px solid var(--accent-color);
}

body.dark-mode .project-option:hover {
    background-color: var(--text-dark-hover);
    color: var(--text-color-dark);
}
